<template>
  <div class="ac-tab">
    <b-card no-body>
      <b-tabs
        v-bind="{
          vertical: this.align === 'vertical',
          ...tabs_attrs,
        }"
      >
      <template slot="tabs">
        <!-- @slot Use this slot for new tab button -->
        <slot name="tabs"></slot>
      </template>

      <template slot="empty">
        <!-- @slot Use this slot if no tabs -->
        <slot name="empty"></slot>
      </template>

        <!-- Tab will be created for each object in data prop -->
        <b-tab
          v-for="tab in data"
          :key="tab.label"
        >
          <!-- @slot Use this slot for tab title -->
          <template slot="title">
            <slot name="title" :data="tab"></slot>
          </template>

          <!-- @slot Slot takes name from 'ref' key inside data -->
          <slot :name="tab.ref" :data="tab"></slot>
        </b-tab>
      </b-tabs>
    </b-card>
  </div>
</template>

<script>
/**
 * ac Tab component
 * @requires VueBootstrap
 */

export default {
  name: 'ac-tab',

  props: {
    /**
     * @param {array} data - Array of objects. Each object will be rendered as tab
     */
    data: {
      type: Array,
      required: true,
    },

    /**
     * @param {string} align - Aligment of tabs.
     * 'horizontal,vertical'. Can be changed in real time
     */
    align: {
      type: String,
      default: 'horizontal',
      validator: value => ['horizontal', 'vertical'].indexOf(value) !== -1,
    },

    /**
     * @param {object} tabs_attrs - Attributes for b-tab.
     */
    tabs_attrs: {
      type: Object,
      required: false,
      default: () => ({}),
    },
  },
}
</script>
